/*
FILE
	extjobqueue.h
	$Id: extjobqueue.h 166 2009-06-05 22:10:35Z Dylan $
AUTHOR
	(C) Gary Wallis and Hugo Urquiza 2001-2009.
	GPL License applies. See LICENSE file.
PURPOSE
	GUI independent code header file:
	Processing mysqlISP2 or other externally created jobs.
	Externally means not created by mysqlBind2/iDNS or it's interfaces.
NOTES
	Used temporarily via bind.c as include file
*/

//data

MYSQL mysqlext;
typedef struct {

	char cZone[100];
	char cMainAddress[16];
	char cTarget[100];
	char cParkedDomains[256];
	char cNameServer[100];
	char cMailServer[100];
	char cMX1[100];
	char cMX2[100];
	char cHostmaster[100];
	unsigned uRevDns;
	unsigned uExpire;
	unsigned uRefresh;
	unsigned uTTL;
	unsigned uRetry;
	unsigned uZoneTTL;
	unsigned uMailServer;
	unsigned uNSSet;

	//tClient
	unsigned uISPClient; 
	char cClientName[33];//cLabel

	//Input markers
	unsigned uParamZone;
	unsigned uParamMainAddress;
	unsigned uParamTarget;
	unsigned uParamParkedDomains;
	unsigned uParamNSSet;
	unsigned uParamMailServer;
	unsigned uParamRevDns;
	unsigned uParamMX1;
	unsigned uParamMX2;
	unsigned uParamClientName;

} structExtJobParameters;

int SubmitISPJob(const char *cJobName,const char *cJobData,
		const char *cServer,unsigned uJobDate);
int InformExtJob(const char *cRemoteMsg,const char *cServer,
		unsigned uJob,unsigned uJobStatus);
void InitializeParams(structExtJobParameters *structExtParam);
void ParseExtParams(structExtJobParameters *structExtParam, char *cJobData);
void CreateNewClient(structExtJobParameters *structExtParam);

void ExtConnectDb(unsigned uHtml);
unsigned uGetClientOwner(unsigned uClient);
void ProcessExtJobQueue(char *cServer);
unsigned WebNew(structExtJobParameters *structExtParam,unsigned uJob,
		char *cServer,unsigned uClient,unsigned uOwner);
unsigned WebMod(structExtJobParameters *structExtParam,
		unsigned uZone,unsigned uJob, char *cServer,unsigned uOwner);
unsigned ModZone(structExtJobParameters *structExtParam,
		unsigned uZone,unsigned uExtJob, char *cServer,unsigned uOwner);
unsigned CancelZone(structExtJobParameters *structExtParam,
		unsigned uZone,unsigned uJob, char *cServer,unsigned uOwner);
int SubmitSingleExtJob(const char *cCommand,const char *cZoneArg, unsigned uNSSetArg,
		const char *cTargetServer, unsigned uPriorityArg, unsigned uTimeArg
	       	,unsigned *uMasterJob,unsigned uExtJob,unsigned uOwner);
int SubmitExtJob(const char *cCommand, unsigned uNSSetArg, const char *cZoneArg,
		unsigned uPriorityArg, unsigned uTimeArg, unsigned uExtJob,unsigned uOwner);
unsigned NewSimpleZone(structExtJobParameters *structExtParam,
		unsigned uJob, char *cServer,unsigned uClient,unsigned uOwner);
unsigned NewSimpleWebZone(structExtJobParameters *structExtParam,
		unsigned uJob, char *cServer,unsigned uClient,unsigned uOwner);
void CreateWebZone(char *cDomain, char *cIP, char *cNameServer,
		char *cMailServer,unsigned uClient,unsigned uOwner);
void DropZone(char *cDomain, char *cNameServer);
unsigned GetuZone(char *cLabel, char *cTable);

//mysqlISP constants
//tJob.uJobStatus
#define mysqlISP_RemotelyQueued 7
#define mysqlISP_Waiting 10
//tInstance.uStatus:
#define mysqlISP_Deployed 4
#define mysqlISP_Canceled 5
#define mysqlISP_OnHold 6
//

